Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## sim.field.grid
Class DoubleGrid2D

    java.lang.Object
      sim.field.grid.AbstractGrid2D
          sim.field.grid.DoubleGrid2D

All Implemented Interfaces:
  Grid2D, java.io.Serializable

public class DoubleGrid2D
extends AbstractGrid2D

A wrapper for 2D arrays of doubles.

This object expects that the 2D arrays are rectangular. You are encouraged to access the array directly. The object implements all of the Grid2D interface. See Grid2D for rules on how to properly implement toroidal or hexagonal grids.

The width and height of the object are provided to avoid having to say field[x].length, etc.

See Also:
  Serialized Form

Field Summary
`double[][]` | `field`

Fields inherited from class sim.field.grid.AbstractGrid2D
`height, width`

Constructor Summary
`DoubleGrid2D(DoubleGrid2D values)`
`DoubleGrid2D(int width, int height)`
`DoubleGrid2D(int width, int height, double initialValue)`

Method Summary
`DoubleGrid2D` | `add(double withThisMuch)` Sets each value in the grid to that value added to withThisMuch Returns the modified grid.
`DoubleGrid2D` | `add(DoubleGrid2D withThis)` Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid.
`DoubleGrid2D` | `add(IntGrid2D withThis)` Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid.
`DoubleGrid2D` | `ceiling()` Sets each value in the grid to ceil(value).
`DoubleGrid2D` | `floor()` Sets each value in the grid to floor(value).
`double` | `get(int x, int y)` Returns the element at location (x,y)
`double[][]` | `getField()`
`DoubleBag` | `getNeighborsHamiltonianDistance(int x, int y, int dist, boolean toroidal, DoubleBag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist.
`DoubleBag` | `getNeighborsHexagonalDistance(int x, int y, int dist, boolean toroidal, DoubleBag result, IntBag xPos, IntBag yPos)` Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive.
`DoubleBag` | `getNeighborsMaxDistance(int x, int y, int dist, boolean toroidal, DoubleBag result, IntBag xPos, IntBag yPos)` Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist.
`DoubleGrid2D` | `lowerBound(double toNoLowerThanThisMuch)` Thresholds the grid so that values smaller than toNoLowerThanThisMuch are changed to toNoLowerThanThisMuch Returns the modified grid.
`double` | `max()` Returns the maximum value stored in the grid
`double` | `mean()` Returns the mean value stored in the grid
`double` | `min()` Returns the minimum value stored in the grid
`DoubleGrid2D` | `multiply(double byThisMuch)` Sets each value in the grid to that value multiplied byThisMuch Returns the modified grid.
`DoubleGrid2D` | `multiply(DoubleGrid2D withThis)` Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid.
`DoubleGrid2D` | `multiply(IntGrid2D withThis)` Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid.
`DoubleGrid2D` | `rint()` Sets each value in the grid to rint(value).
`void` | `set(int x, int y, double val)` Sets location (x,y) to val
`DoubleGrid2D` | `setTo(double thisMuch)` Sets all the locations in the grid the provided element
`DoubleGrid2D` | `setTo(DoubleGrid2D values)` Changes the dimensions of the grid to be the same as the one provided, then sets all the locations in the grid to the elements at the quivalent locations in the provided grid.
`DoubleGrid2D` | `truncate()` Eliminates the decimal portion of each value in the grid (rounds towards zero).
`DoubleGrid2D` | `upperBound(double toNoMoreThanThisMuch)` Thresholds the grid so that values greater to toNoMoreThanThisMuch are changed to toNoMoreThanThisMuch.

Methods inherited from class sim.field.grid.AbstractGrid2D
`dlx, dly, downx, downy, drx, dry, getHeight, getNeighborsHamiltonianDistance, getNeighborsHexagonalDistance, getNeighborsMaxDistance, getWidth, stx, sty, trb, trt, tx, ty, ulx, uly, upx, upy, urx, ury`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### field

    public double[][] field

Constructor Detail

### DoubleGrid2D

    public DoubleGrid2D(int width,
                        int height)

### DoubleGrid2D

    public DoubleGrid2D(int width,
                        int height,
                        double initialValue)

### DoubleGrid2D

    public DoubleGrid2D(DoubleGrid2D values)

Method Detail

### getField

    public double[][] getField()

### set

    public final void set(int x,
                          int y,
                          double val)

  Sets location (x,y) to val

### get

    public final double get(int x,
                            int y)

  Returns the element at location (x,y)

### setTo

    public final DoubleGrid2D setTo(double thisMuch)

  Sets all the locations in the grid the provided element

### setTo

    public final DoubleGrid2D setTo(DoubleGrid2D values)

  Changes the dimensions of the grid to be the same as the one provided, then sets all the locations in the grid to the elements at the quivalent locations in the provided grid.

### max

    public final double max()

  Returns the maximum value stored in the grid

### min

    public final double min()

  Returns the minimum value stored in the grid

### mean

    public final double mean()

  Returns the mean value stored in the grid

### upperBound

    public final DoubleGrid2D upperBound(double toNoMoreThanThisMuch)

  Thresholds the grid so that values greater to toNoMoreThanThisMuch are changed to toNoMoreThanThisMuch. Returns the modified grid.

### lowerBound

    public final DoubleGrid2D lowerBound(double toNoLowerThanThisMuch)

  Thresholds the grid so that values smaller than toNoLowerThanThisMuch are changed to toNoLowerThanThisMuch Returns the modified grid.

### add

    public final DoubleGrid2D add(double withThisMuch)

  Sets each value in the grid to that value added to withThisMuch Returns the modified grid.

### add

    public final DoubleGrid2D add(IntGrid2D withThis)

  Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid. Returns the modified grid.

### add

    public final DoubleGrid2D add(DoubleGrid2D withThis)

  Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid. Returns the modified grid.

### multiply

    public final DoubleGrid2D multiply(double byThisMuch)

  Sets each value in the grid to that value multiplied byThisMuch Returns the modified grid.

### multiply

    public final DoubleGrid2D multiply(IntGrid2D withThis)

  Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid. Returns the modified grid.

### multiply

    public final DoubleGrid2D multiply(DoubleGrid2D withThis)

  Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid. Returns the modified grid.

### floor

    public final DoubleGrid2D floor()

  Sets each value in the grid to floor(value). Returns the modified grid.

### ceiling

    public final DoubleGrid2D ceiling()

  Sets each value in the grid to ceil(value). Returns the modified grid.

### truncate

    public final DoubleGrid2D truncate()

  Eliminates the decimal portion of each value in the grid (rounds towards zero). Returns the modified grid.

### rint

    public final DoubleGrid2D rint()

  Sets each value in the grid to rint(value). That is, each value is rounded to the closest integer value. If two integers are the same distance, the value is rounded to the even integer. Returns the modified grid.

### getNeighborsMaxDistance

    public final DoubleBag getNeighborsMaxDistance(int x,
                                                   int y,
                                                   int dist,
                                                   boolean toroidal,
                                                   DoubleBag result,
                                                   IntBag xPos,
                                                   IntBag yPos)

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y) ) <= dist. This region forms a square 2*dist+1 cells across, centered at (X,Y). If dist==1, this is equivalent to the so-called "Moore Neighborhood" (the eight neighbors surrounding (X,Y)), plus (X,Y) itself. Places each x and y value of these locations in the provided DoubleBags xPos and yPos, clearing the bags first. Then places into the result DoubleBag the elements at each of those locations clearning it first. Returns the result DoubleBag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

### getNeighborsHamiltonianDistance

    public final DoubleBag getNeighborsHamiltonianDistance(int x,
                                                           int y,
                                                           int dist,
                                                           boolean toroidal,
                                                           DoubleBag result,
                                                           IntBag xPos,
                                                           IntBag yPos)

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) <= dist. This region forms a diamond 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y). If dist==1 this is equivalent to the so-called "Von-Neumann Neighborhood" (the four neighbors above, below, left, and right of (X,Y)), plus (X,Y) itself. Places each x and y value of these locations in the provided DoubleBags xPos and yPos, clearing the bags first. Then places into the result DoubleBag the elements at each of those locations clearning it first. Returns the result DoubleBag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

### getNeighborsHexagonalDistance

    public final DoubleBag getNeighborsHexagonalDistance(int x,
                                                         int y,
                                                         int dist,
                                                         boolean toroidal,
                                                         DoubleBag result,
                                                         IntBag xPos,
                                                         IntBag yPos)

  Gets all neighbors located within the hexagon centered at (X,Y) and 2*dist+1 cells from point to opposite point inclusive. If dist==1, this is equivalent to the six neighbors immediately surrounding (X,Y), plus (X,Y) itself. Places each x and y value of these locations in the provided DoubleBags xPos and yPos, clearing the bags first. Then places into the result DoubleBag the elements at each of those locations clearning it first. Returns the result DoubleBag (constructing one if null had been passed in). null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD